<template>
  <div class="flex flex-wrap w-full black-feature-hover">
    <el-scrollbar class="w-full">
      <!--  max-h-[500px] -->
      <div
        class="flex flex-wrap my-4 justify-center items-start max-h-[550px]"
        :class="featureProducts?.length <= 6 ? '' : 'items-start'"
      >
        <div
          v-for="product in featureProducts"
          :key="product.GameId"
          class="product-item"
        >
          <div
            v-if="product.LinkOption !== '' && product.GameId !== 73"
            class="mx-3 pointer"
            :class="
              product.IsMaintain ? 'grayscale-[1] pointer-events-none' : ''
            "
            @click="
              auth
                ? handleReloadRoute(
                    processingUrl(
                      product.LinkOption,
                      EnumEntranceLocation.Hover
                    )
                  )
                : DialogOrRedirect()
            "
          >
            <div>
              <div class="w-[153px] h-[153px] mb-2">
                <img
                  :src="product.GameIconUrl"
                  class="object-contain w-full h-full"
                />
              </div>
              <div class="provider-name">
                {{ checkVSNameMapping(product) }}
              </div>
            </div>
            <div
              v-if="product.IsMaintain"
              class="absolute w-12 h-12 top-[50px] left-[50px] z-[2]"
            >
              <img
                :src="
                  getAssetImage(
                    'assets/theme/common/icon/icon_maintainance.png'
                  )
                "
                alt=""
              />
            </div>
          </div>
          <div
            v-else-if="product.GameId === 73"
            class="mx-3 pointer"
            :class="
              product.IsMaintain ? 'grayscale-[1] pointer-events-none' : ''
            "
            @click="
              auth
                ? handleGameEntryOpenWindow(
                    product,
                    375,
                    667,
                    EnumEntranceLocation.Hover
                  )
                : DialogOrRedirect()
            "
          >
            <div>
              <div class="w-[153px] h-[153px] mb-2">
                <img
                  :src="product.GameIconUrl"
                  class="object-contain w-full h-full"
                />
              </div>
              <div class="provider-name">
                {{ checkVSNameMapping(product) }}
              </div>
            </div>
            <div
              v-if="product.IsMaintain"
              class="absolute w-12 h-12 top-[50px] left-[50px] z-[2]"
            >
              <img
                :src="
                  getAssetImage(
                    'assets/theme/common/icon/icon_maintainance.png'
                  )
                "
                alt=""
              />
            </div>
          </div>
          <div
            v-else
            class="mx-3 pointer"
            :class="
              product.IsMaintain ? 'grayscale-[1] pointer-events-none' : ''
            "
            @click="
              auth
                ? handleGameEntryOpenWindow(
                    product,
                    850,
                    850,
                    EnumEntranceLocation.Hover
                  )
                : DialogOrRedirect()
            "
          >
            <div>
              <div class="w-[153px] h-[153px] mb-2">
                <img
                  :src="product.GameIconUrl"
                  class="object-contain w-full h-full"
                />
              </div>
              <div class="provider-name">
                {{ checkVSNameMapping(product) }}
              </div>
            </div>
            <div
              v-if="product.IsMaintain"
              class="absolute w-12 h-12 top-[60px] left-[55px] z-[2]"
            >
              <img
                :src="
                  getAssetImage(
                    'assets/theme/common/icon/icon_maintainance.png'
                  )
                "
                alt=""
              />
            </div>
          </div>
        </div>
      </div>
    </el-scrollbar>
  </div>
</template>

<script lang="ts">
import _ from "lodash";
import { defineComponent, PropType, ref } from "vue";
import { useRouter } from "vue-router";
import { IGame } from "@/models/IGetPlayableGamesResponse";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";
import {
  handleReloadRoute,
  handleGameEntryOpenWindow,
} from "@/composables/useTheme";
import useProductFeature from "@/composables/useProductFeature";

export default defineComponent({
  name: "BlackProductFeatureTabHover",
  props: {
    featureProducts: {
      type: Object as PropType<Array<IGame>>,
      required: true,
    },
  },
  emits: ["update:isFeatureHover"],
  setup(props, { emit }) {
    const { getAssetImage } = commonHelper;
    const router = useRouter();
    const Dialog = ref(false);
    const { auth, processingUrl, selectedThemeName } = useProductFeature();
    const onChangeProductFeature = (event: boolean) => {
      emit("update:isFeatureHover", event);
    };
    const DialogOrRedirect = () => {
      if (selectedThemeName.value !== "sbo") {
        onChangeProductFeature(false);
        router.push("/login");
      } else {
        Dialog.value = true;
      }
    };
    const checkVSNameMapping = (product: IGame): string => {
      if (product.GameId === 1) return product.GameName;
      const named = _.toLower(
        _.replace(product.GameProviderName, new RegExp(/\W/g), "")
      );
      const isVirtualSport =
        _.toLower(_.replace(product.TabType ?? "", " ", "")) ===
        "virtualsports";
      const nameChecked =
        _.includes(_.replace(named, "-", ""), "sbobet") && isVirtualSport
          ? "SBO VIRTUAL SPORTS"
          : product.GameProviderDisplayName;

      return nameChecked;
    };
    return {
      auth,
      handleReloadRoute,
      handleGameEntryOpenWindow,
      processingUrl,
      EnumEntranceLocation,
      DialogOrRedirect,
      getAssetImage,
      checkVSNameMapping,
    };
  },
});
</script>

<style scoped lang="scss">
.provider-name {
  text-align: center;
  font-size: 16px;
  color: var(--text5);
}
/* Scroll bar stylings */
.overflow-x-scroll.items-start.justify-start::-webkit-scrollbar,
.overflow-x-scroll.items-start.justify-start::-webkit-scrollbar {
  width: 7px;
  height: 10px;
}

/* Track */
.overflow-x-scroll.items-start.justify-start::-webkit-scrollbar-track,
.overflow-x-scroll.items-start.justify-start::-webkit-scrollbar-track {
  box-shadow: inset 0 0 5px rgb(197 196 196);
  border-radius: 5px;
}

/* Handle */
.overflow-x-scroll.items-start.justify-start::-webkit-scrollbar-thumb,
.overflow-x-scroll.items-start.justify-start::-webkit-scrollbar-thumb {
  background: var(--primary);
  border-radius: 5px;
}

.product-item {
  width: 16.66%; // 6 games per row
  display: flex;
  align-items: center;
  justify-content: center;
  cursor: pointer;
}
</style>
